> For the complete documentation index, see [llms.txt](https://docs.gamma.xyz/gamma/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.gamma.xyz/gamma/lp-vaults/developer-portal.md).

# Developer Portal

## Vault (Hypervisor) Deposit

### Contracts

* UniProxy.sol →  Deposit proxy contract with information about deposit ratios.  All deposits must go thru UniProxy, not Hypervisor
* Hypervisor.sol →  Main vault manager contract with information about both base and limit liquidity ranges and amounts.  To withdraw, interact with the Hypervisor.

### Deposit

Functionally the source of any integration would require

#### 1. Getting the ratio of assets

UniProxy.getDepositAmount( lpTokenAddress, tokenProvidedAddress, tokenProvidedQuantity )

returns \[minQuanity, maxQuantity]

#### 2.  Deposting via the UniProxy →  UniProxy.deposit()

UniProxy.deposit( token0Quantity, token1Quantity, userAddress, lpTokenAddress )

### Withdrawal

Hypervisor.withdraw( lpTokenQuantityToBurn, destinationAddress, sourceAddress, \[0,0,0,0] )

(where "Hypervisor" is the lp token contract, destinationAddress is destination for redeemed token0, token1, sourceAddress is holder of the lp tokens, \[0,0,0,0] is a min-out constraint only used on L1)


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.gamma.xyz/gamma/lp-vaults/developer-portal.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
